/**
 * \file device.h
 *
 * \brief ޲`Ԑݒ
 *
 * ̧قTPIɂ۸ݸނ邱ƂӐ}޲̌`Ԑݒ܂BATtiny4/5/9/10/20/40x܂B
 *
 * 쌠 (c) 2011, Atmel Corporation S\ς݁B
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef DEVICE_H_INCLUDED
#define DEVICE_H_INCLUDED

/* TPI */

#define NVM_PROGRAM_ENABLE		0x1289AB45CDD888FF

/* TPI߈ꎮ */

#define SLD						0b00100000
#define SLD_POSTINC				0b00100100
#define SST						0b01100000
#define SST_POSTINC				0b01100100
#define SSTPR					0b01101000
#define SIN						0b00010000
#define SOUT					0b10010000
#define SLDCS					0b10000000
#define SSTCS					0b11000000
#define SKEY					0b11100000

/* TPI/ڼ޽ */

#define TPISR					0b00000000
#define TPIPCR					0b00000010
#define TPIIR					0b00001111

/* NVM */
#define NVMCMD_NO_OPERATION		0x00
#define NVMCMD_CHIP_ERASE		0x10
#define NVMCMD_SECTION_ERASE	0x14
#define NVMCMD_MEMORY_WRITE		0x1D

#if defined ATTINY10
  #define words_to_write		1
#elif defined ATTINY20
  #define words_to_write		2
#elif defined ATTINY40
  #define words_to_write		4
#endif

/* ؋Ԓ` */
#define IO_SPACE_START			0x0000
#define IO_SPACE_END			0x003F
#define SRAM_DATA_MEMORY_START	0x0040
#define SRAM_DATA_MEMORY_END	0x005F
#define NVM_LOCK_BITS_START		0x3F00
#define NVM_LOCK_BITS_SIZE		2
#define CONF_BITS_START			0x3F40
#define CONF_BITS_SIZE			2
#define CALIB_BITS_START		0x3F80
#define CALIB_BITS_SIZE			2
#define DEV_ID_START			0x3FC0
#define DEV_ID_SIZE				3
#define NVM_PROG_MEM_START		0x4000

#if defined ATTINY10
  #define NVM_PROG_MEM_END		0x43FF
#elif defined ATTINY20
  #define NVM_PROG_MEM_END		0x47FF
#elif defined ATTINY40
  #define NVM_PROG_MEM_END		0x4FFF
#endif
#define FLASH_PAGE_SIZE			16

#define GAURD_TIME_128			0
#define GAURD_TIME_64			1
#define GAURD_TIME_32			2
#define GAURD_TIME_16			3
#define GAURD_TIME_8			4
#define GAURD_TIME_4			5
#define GAURD_TIME_2			6
#define GAURD_TIME_0			7

#endif /* DEVICE_H_INCLUDED*/
