/**
 * \file usart_driver.c
 *
 * \brief USARTʐMpײ ٰ
 *
 * ̧قTPIAVROSPʐMɎgpKvUSART01̊֐܂݂܂B
 *
 * 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#include "usart_driver.h"

/* TPIʐMpUSART */
void tpi_comm_init()
{
	DDRD |= (1<<TPI_CLK);
	/* TPIۯgݒ */
	UBRR1H = (TPI_BAUD>>8);
	UBRR1L =  TPI_BAUD;
	/* 񓯊USARTAڰь`ST,8,E,SP1,SP2 */
	UCSR1C =(1<<UMSEL10)|(1<< USBS1) |(1<<UPM11)|(1<<UCSZ11)|(1<<UCSZ10)|(1<<UCPOL1);
}

/* TPIoR1޲ĎMAMlԂB */
uint8_t tpi_receive_byte (void)
{
	uint8_t timeout=100,rx_data;

	tpi_transmit_disable();
	tpi_receive_enable();
	// ް҂
	while(!(UCSR1A & (1<<RXC1)))
	{
		if(!timeout--) break;
	}
	rx_data=UDR1;
	return rx_data;
}

/* TPIoR1޲đo
** tx_data : ׂް
*/
void tpi_send_byte (uint8_t tx_data)
{
	tpi_receive_disable();
	tpi_transmit_enable();
	while (PIND & (1 << TPI_CLK));
	while (!(PIND & (1 << TPI_CLK)));

	while (!(UCSR1A & (1<<UDRE1)));			// WMɏՕ󂫑҂
	UCSR1A|=(1<<TXC1);
	UDR1 = tx_data;							// MJn
}

/* AVROSPʐMpUART */
void avrosp_comm_init (void)
{
	DDRD |= (1<<AVROSP_TXD);
	/* AVROSPްڰ */
	UBRR0H =  (AVROSP_BAUD>>8);
	UBRR0L =  AVROSP_BAUD;
	/* 񓯊USARTAڰь`ST,8,SP1 */
 	UCSR0C =(1<<UCSZ01)|(1<<UCSZ00);
	/* M */
 	UCSR0B |= (1<<RXEN0)|(1<<TXEN0);
}

/* AVROSP1޲đo
** tx_data : UARToRőׂް
*/
void avrosp_send_byte (char tx_data)
{
	/* MɏՕ󂫑҂ */
	while (!(UCSR0A & (1<<UDRE0)));
	UCSR0A|=(1<<TXC0);
	/* MJn */
	UDR0 = tx_data;
}

/* AVROSP1޲ēǂݍ݁AMlԂB */
uint8_t avrosp_receive_byte (void)
{
	volatile uint8_t rx_data;
	/* ް҂ */
	while(!(UCSR0A & (1<<RXC0)));
	rx_data=UDR0;
	return rx_data;
}
